using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;       // for process(notepad)
using System.Drawing;
using System.IO;        // to open, save txt
using System.Text;
using System.Windows.Forms;

namespace AutoLog
{
    public partial class AddForm : Form
    {
        public AddForm()
        {
            InitializeComponent();
            this.FormClosing += new FormClosingEventHandler(AddForm_FormClosing);
        }

        private void AddForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (MessageBox.Show("ϰڽϱ?", "", MessageBoxButtons.YesNo) == DialogResult.No)
            {
                // no  
                e.Cancel = true;
            }
            // yes 
        }

        private string l = Environment.NewLine;     //  

        //    
        private void buttonOpenPath_Click(object sender, EventArgs e)
        {
            this.openFileDialog.ShowDialog();
        }

        //     
        private void openFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            this.textBoxOpen.Text = this.openFileDialog.FileName;
            this.buttonOpen.Enabled = true;
        }

        //   Ŭ
        private void buttonOpen_Click(object sender, EventArgs e)
        {
            this.readFIle();
            this.groupBoxBefore.Enabled = true;
            this.panelAdd.Enabled = true;
        }

        //  о
        private void readFIle()
        {
            FileStream fs = new FileStream(this.textBoxOpen.Text, FileMode.Open);
            StreamReader sr = new StreamReader(fs);
            this.fillInfo(sr.ReadToEnd());
            fs.Close();
            sr.Close();
        }

        //   ä
        private void fillInfo(string context)
        {
            string[] split = this.textBoxOpen.Text.Split(new char[] { Convert.ToChar(92), '.' });   // \
            this.textBoxName.Text = split[split.Length - 2];        // α׷ ̸

            this.textBoxBeforeContext.Text = context;       // () 

            this.findVersion();     //   

            this.addToday();        //  

            this.textBoxSave.Text = this.textBoxOpen.Text;      //  
            this.saveFileDialog.FileName = this.textBoxName.Text + ".log";
        }

        //  ȣ ã
        private void findVersion()
        {
            string[] split = this.textBoxBeforeContext.Text.Split(new char[] { '(', '.', ')'});
            this.textBoxVersion1.Text = split[1];
            this.textBoxVersion2.Text = split[2];
            this.textBoxVersion3.Text = split[3];
        }

        private void addToday()
        {
            this.textBoxAddContext.Text = DateTime.Now.Year.ToString() + "/" + DateTime.Now.ToString("MM") + "/" + DateTime.Now.ToString("dd");     // date
            this.textBoxAddContext.Text += " (" + this.textBoxVersion1.Text + "." + this.textBoxVersion2.Text + "." + Convert.ToString(Convert.ToInt32(this.textBoxVersion3.Text) + 1) + ")";      // next version
            this.textBoxAddContext.Text += l + "- " + l + l;
            this.textBoxAddContext.Text += this.textBoxBeforeContext.Text;
        }

        //    
        private void buttonSavePath_Click(object sender, EventArgs e)
        {
            this.saveFileDialog.ShowDialog();
        }

        //     
        private void saveFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            this.textBoxSave.Text = this.saveFileDialog.FileName;
        }

        //   Ŭ
        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(" Ͻðڽϱ?", "Save", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                try
                {
                    FileStream fs = new FileStream(this.textBoxSave.Text, FileMode.Open);
                    StreamWriter sw = new StreamWriter(fs);
                    sw.Write(this.textBoxAddContext.Text);
                    sw.Close();
                    fs.Close();
                    if (MessageBox.Show("Ǿϴ.  ðڽϱ?", "Save", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    {
                        Process.Start("notepad.exe", this.textBoxSave.Text);
                    }
                }
                catch (Exception saveEx)
                {
                    // Ʈ ex
                    MessageBox.Show("Error in file save", "Error!");
                }
            }
        }
    }
}